import pdb

from _typeshed import Incomplete
from tabcompleter import ConfigurableClass

__url__: str
__version__: Incomplete
run_from_main: bool
side_effects_free: Incomplete

def import_from_stdlib(name): ...

pdb: Incomplete

def rebind_globals(func, newglobals): ...
def is_char_wide(char): ...
def get_width(line): ...
def set_line_width(line, width, tll: bool = True): ...

class DefaultConfig:
    prompt: str
    highlight: bool
    sticky_by_default: bool
    bg: str
    use_pygments: bool
    colorscheme: Incomplete
    use_terminal256formatter: Incomplete
    editor: str
    stdin_paste: Incomplete
    exec_if_unfocused: Incomplete
    truncate_long_lines: bool
    shorten_path: bool
    disable_pytest_capturing: bool
    enable_hidden_frames: bool
    show_hidden_frames_count: bool
    encodings: Incomplete
    filename_color: Incomplete
    line_number_color: Incomplete
    regular_stack_color: Incomplete
    pm_stack_color: Incomplete
    stack_color = regular_stack_color
    return_value_color: str
    pm_return_value_color: str
    num_return_value_color: str
    true_return_value_color: str
    false_return_value_color: str
    none_return_value_color: str
    regular_line_color: str
    pm_cur_line_color: str
    exc_line_color: str
    current_line_color = regular_line_color
    exception_caught: bool
    last_return_color: Incomplete
    show_traceback_on_error: bool
    show_traceback_on_error_limit: Incomplete
    default_pdb_kwargs: Incomplete
    def setup(self, pdb) -> None: ...
    def before_interaction_hook(self, pdb) -> None: ...

def setbgcolor(line, color): ...

CLEARSCREEN: str

def lasti2lineno(code, lasti): ...

class Restart(Exception): ...
class Undefined: ...

undefined: Incomplete

class Pdb(pdb.Pdb, ConfigurableClass):
    DefaultConfig = DefaultConfig
    config_filename: str
    ConfigFactory: Incomplete
    start_lineno: Incomplete
    start_filename: Incomplete
    config: Incomplete
    prompt: Incomplete
    display_list: Incomplete
    sticky: Incomplete
    first_time_sticky: Incomplete
    ok_to_clear: bool
    has_traceback: bool
    sticky_ranges: Incomplete
    tb_lineno: Incomplete
    history: Incomplete
    show_hidden_frames: bool
    stdout: Incomplete
    saved_curframe: Incomplete
    last_cmd: Incomplete
    def __init__(self, *args, **kwds) -> None: ...
    def ensure_file_can_write_unicode(self, f): ...
    def interaction(self, frame, traceback) -> None: ...
    def print_hidden_frames_count(self) -> None: ...
    def setup(self, frame, tb): ...
    fullstack: Incomplete
    def get_stack(self, f, t): ...
    def compute_stack(self, fullstack, idx: Incomplete | None = None): ...
    curindex: Incomplete
    curframe: Incomplete
    def refresh_stack(self) -> None: ...
    raise_lineno: Incomplete
    def forget(self) -> None: ...
    def complete(self, text, state): ...
    stack_entry_regexp: Incomplete
    def format_stack_entry(self, frame_lineno, lprefix: str = ": "): ...
    def try_to_decode(self, s): ...
    def format_source(self, src): ...
    def format_line(self, lineno, marker, line): ...
    def parseline(self, line): ...
    def do_inspect(self, arg) -> None: ...
    def default(self, line): ...
    def do_help(self, arg): ...
    def help_hidden_frames(self) -> None: ...
    def do_longlist(self, arg) -> None: ...
    do_ll = do_longlist
    def do_jump(self, arg) -> None: ...
    do_j = do_jump
    def do_list(self, arg) -> None: ...
    do_l = do_list
    def do_continue(self, arg): ...
    do_c = do_continue
    do_cont = do_continue
    def do_next(self, arg): ...
    do_n = do_next
    def do_step(self, arg): ...
    do_s = do_step
    def do_until(self, arg): ...
    do_unt = do_until
    def do_p(self, arg) -> None: ...
    def do_pp(self, arg) -> None: ...
    def do_debug(self, arg): ...
    def do_run(self, arg) -> None: ...
    do_restart = do_run
    def do_interact(self, arg) -> None: ...
    def do_track(self, arg) -> None: ...
    def do_display(self, arg) -> None: ...
    def do_undisplay(self, arg) -> None: ...
    sticky_range: Incomplete
    def do_sticky(self, arg) -> None: ...
    def do_truncate(self, arg) -> None: ...
    do_trun = do_truncate
    def print_stack_trace(self) -> None: ...
    def print_stack_entry(
        self, frame_lineno, prompt_prefix=..., frame_index: Incomplete | None = None
    ) -> None: ...
    def print_current_stack_entry(self) -> None: ...
    def preloop(self) -> None: ...
    def do_source(self, arg) -> None: ...
    curframe_locals: Incomplete
    lineno: Incomplete
    def do_frame(self, arg) -> None: ...
    do_f = do_frame
    def do_up(self, arg: str = "1") -> None: ...
    do_u = do_up
    def do_down(self, arg: str = "1") -> None: ...
    do_d = do_down
    def do_where(self, arg) -> None: ...
    do_w = do_where
    do_bt = do_where
    @staticmethod
    def get_terminal_size(): ...
    def do_edit(self, arg) -> None: ...
    def set_trace(self, frame: Incomplete | None = None): ...
    def is_skipped_module(self, module_name): ...
    def message(self, msg) -> None: ...
    def error(self, msg) -> None: ...

func: Incomplete

def post_mortem(t: Incomplete | None = None, Pdb=...) -> None: ...

GLOBAL_PDB: Incomplete

def set_trace(
    frame: Incomplete | None = None, header: Incomplete | None = None, Pdb=..., **kwds
) -> None: ...
def cleanup() -> None: ...
def xpm(Pdb=...) -> None: ...
def enable() -> None: ...
def disable() -> None: ...
def set_tracex() -> None: ...
def hideframe(func): ...
def always(obj, value): ...
def break_on_setattr(attrname, condition=..., Pdb=...): ...
def print_pdb_continue_line() -> None: ...
def main() -> None: ...
